---
title: PublicKeyCredentialRequestOptions
slug: Web/API/PublicKeyCredentialRequestOptions
tags:
  - API
  - Dictionary
  - PublicKeyCredentialRequestOptions
  - Reference
  - Web Authentication API
  - WebAuthn
---
<div>{{APIRef("Web Authentication API")}}{{securecontext_header}}</div>

<p>The <code><strong>PublicKeyCredentialRequestOptions</strong></code> dictionary of the <a href="/en-US/docs/Web/API/Web_Authentication_API">Web Authentication API</a> holds the options passed to {{domxref("CredentialsContainer.get()","navigator.credentials.get()")}} in order to fetch a given {{domxref("PublicKeyCredential")}}.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("PublicKeyCredentialRequestOptions.challenge")}}</dt>
 <dd>A {{domxref("BufferSource")}}, emitted by the relying party's server and used as a <a href="https://en.wikipedia.org/wiki/Challenge%E2%80%93response_authentication">cryptographic challenge</a>. This value will be signed by the authenticator and the signature will be sent back as part of {{domxref("AuthenticatorAssertionResponse.signature")}}.</dd>
 <dt>{{domxref("PublicKeyCredentialRequestOptions.timeout")}} {{optional_inline}}</dt>
 <dd>A numerical hint, in milliseconds, which indicates the time the caller is willing to wait for the retrieval operation to complete. This hint may be overridden by the browser.</dd>
 <dt>{{domxref("PublicKeyCredentialRequestOptions.rpId")}} {{optional_inline}}</dt>
 <dd>A {{domxref("USVString")}} which indicates the relying party's identifier (ex. <code>"login.example.org"</code>). If this option is not provided, the client will use the current origin's domain.</dd>
 <dt>{{domxref("PublicKeyCredentialRequestOptions.allowCredentials")}} {{optional_inline}}</dt>
 <dd>An {{jsxref("Array")}} of credentials descriptor which restricts the acceptable existing credentials for retrieval.</dd>
 <dt>{{domxref("PublicKeyCredentialRequestOptions.userVerification")}} {{optional_inline}}</dt>
 <dd>A string qualifying how the user verification should be part of the authentication process.</dd>
 <dt>{{domxref("PublicKeyCredentialRequestOptions.extensions")}} {{optional_inline}}</dt>
 <dd>An object with several client extensions' inputs. Those extensions are used to request additional processing (e.g. dealing with legacy FIDO APIs credentials, prompting a specific text on the authenticator, etc.).</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">var options = {
  challenge: new Uint8Array([/* bytes sent from the server */]),
  rpId: "example.com", /* will only work if the current domain
                         is something like foo.example.com */
  userVerification: "preferred",
  timeout: 60000,     // Wait for a minute
  allowCredentials: [
    {
      transports: "usb",
      type: "public-key",
      id: new Uint8Array(26) // actually provided by the server
    },
    {
      transports: "internal",
      type: "public-key",
      id: new Uint8Array(26) // actually provided by the server
    }
  ],
  extensions: {
    uvm: true,  // RP wants to know how the user was verified
    loc: false,
    txAuthSimple: "Could you please verify yourself?"
  }
};

navigator.credentials.get({ "publicKey": options })
    .then(function (credentialInfoAssertion) {
    // send assertion response back to the server
    // to proceed with the control of the credential
}).catch(function (err) {
     console.error(err);
});

</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAuthn','#dictdef-publickeycredentialrequestoptions', 'PublicKeyCredentialRequestOptions dictionary')}}</td>
   <td>{{Spec2('WebAuthn')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PublicKeyCredentialRequestOptions")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("PublicKeyCredentialCreationOptions")}}: the dictionary which provides option for the public key credential creation</li>
</ul>
